      program Solo
c
c     ******************************************************************
c     Soloviev  equilibrium
c     ******************************************************************
c
      implicit double precision (a-h,o-z)
c
      dimension x(-100:100), y(-100:100), psi(-100:100,-100:100), pc(26)
      real lam
      character*80 text
C
c     * initiate plotting
      call ppp
      call begplt('Solo.ps')
      call lbltop('Soloviev equilibria',19)
      call lblbot('Program Solo',12)
c
c     * grid
      int = 100
      do 10 i = -int, int
         x(i) = float(i)/float(int)
         y(i) = float(i)/float(int)
   10 continue
c
      do 40 l = 1, 4
c
      eps  = 0.4
      boa  = 1.
      if(l.eq.1) then
	     lam = -4.5
		 mx = 22
		 my = 2
      elseif(l.eq.2) then
	     lam = -1.5
		 mx = 23
		 my = 2
      elseif(l.eq.3) then
	     lam = 1.
		 mx = 22
		 my = 3
      elseif(l.eq.4) then
	     lam = 2.
		 mx = 23
		 my = 3
      endif
c
c     * Soloviev flux function
      par = 1. + lam - 0.25*eps**2
      do 20 i = -int, int
	  do 20 j = -int, int 
	     psi(i,j) = (x(i) - 0.5*eps*(1. - x(i)**2))**2
     &             + (par*(1. + eps*x(i))**2 - lam)*(y(j)/boa)**2 
		 if(psi(i,j).gt.0.) psi(i,j) = sqrt(abs(psi(i,j)))
   20 continue
c
      do 30 k = 1, 20
   30    pc(k) = k/20.
c
      write(text,'(''eps='',f5.2,'', boa='',f5.2,'', lam='',f6.2)')
     &              eps, boa, lam
      call cplot(mx,my,0,x(-100),y(-100),201,201,1,1,
     &           psi(-100,-100),201,pc,20,text,32,'x',1,'y',1)

   40 continue
c
      call finplt
      end